// Ejercicio 5-4
//
clear
xdel(winsid())
clc
// Transferencia de la planta
s=%s;
Gp=syslin("c",1/(s*(s+10)));
zpk(Gp)
// discretización
z=%z;
Ts=0.05;
G_z=ss2tf(dscr(tf2ss(Gp),Ts))
Gp_z=G_z/z;
zpk(Gp_z)
// Transformación bilineal
Gp_w=ss2tf(bilin(Gp_z,[Ts/2,1,-Ts/2,1]))
[z,p,k]=tf2zp(Gp_w)
// Error en Régimen Permanente
Erp=0.05;
Kv=1/Erp
limKv=horner(s*Gp,0)
limKv=horner((z-1)/Ts*Gp_z,1)
limKv2=horner(s*Gp_w,0)      // Resultado incorrecto debido a tolerancias de las operaciones 
K=Kv/limKv
Gp_w=K*Gp_w
wx=logspace(-2,5,500);
frec=wx/2/%pi;
[fx1,rep] =repfreq(Gp_w,frec);// Calcula la respuesta en frecuencia
                            // en números complejos
[db,phi]=dbphi(rep); // Convierte a dB y Fase
subplot(211)
plot2d("ln",wx,db,color("blue"));
xgrid(color("gray"))
title("Ejercicio 5-4 Diagrama de Bode de Módulo ")
subplot(212)
plot2d("ln",wx,phi,color("red"));
xgrid(color("gray"))
title("Ejercicio 5-4 Diagrama de Bode de Fase")

// Fución para el cálculo de la red de atraso.
function [Gc]=atraso(a,wc)
    // Cálculo de la red de atraso en función 
    // de la atenuación y la frecuencia de corte
    s=%s;
    w0=wc/10;
    wp=w0/a;
    Gc=syslin("c",1+s/w0,1+s/wp);
endfunction;

// Función para el cálculo de la red de adelanto
function [Gc]=adelanto(phi_max,w0)
    // Cálculo de la red de atraso en función 
    // de la atenuación y la frecuencia de corte
    s=%s;
    s_pm=sin(phi_max*%pi/180);
    a=(1+s_pm)/(1-s_pm)
    wp=w0*sqrt(a);
    wc=wp/a;
    Gc=syslin("c",1+s/wc,1+s/wp);
endfunction;

// Compensación con corrección de Fase
xdel(winsid())
Gc1=adelanto(30,10)
zpk(Gc1)
bode(Gc1,"rad")
GH1=Gp_w*Gc1
wx=logspace(-2,5,500);
frec=wx/2/%pi;
[fx1,rep] =repfreq(GH1,frec);// Calcula la respuesta en frecuencia
                            // en números complejos
[db,phi]=dbphi(rep); // Convierte a dB y Fase
subplot(211)
plot2d("ln",wx,db,color("blue"));
xgrid(color("gray"))
title("Ejercicio 5-4 Diagrama de Bode de Módulo ")
subplot(212)
plot2d("ln",wx,phi,color("red"));
xgrid(color("gray"))
title("Ejercicio 5-4 Diagrama de Bode de Fase")
// Compensación del módulo
xdel(winsid())
Gc2=atraso(2.49,10)
zpk(Gc2)
bode(Gc2,"rad")
GH2=GH1*Gc2
wx=logspace(-2,5,500);
frec=wx/2/%pi;
[fx1,rep] =repfreq(GH2,frec);// Calcula la respuesta en frecuencia
                            // en números complejos
[db,phi]=dbphi(rep); // Convierte a dB y Fase
subplot(211)
plot2d("ln",wx,db,color("blue"));
xgrid(color("gray"))
title("Ejercicio 5-4 Diagrama de Bode de Módulo ")
subplot(212)
plot2d("ln",wx,phi,color("red"));
xgrid(color("gray"))
title("Ejercicio 5-4 Diagrama de Bode de Fase")
// Compensador completo
Gc=K*Gc1*Gc2;
zpk(Gc)
// Transformación bilineal
D_z=ss2tf(bilin(Gc,[2/Ts,-2/Ts,1,1]))
zpk(D_z)
// Respuesta Transitoria
xdel(winsid())
Tlc=D_z*Gp_z/(1+D_z*Gp_z);
tiempo=[0:Ts:3]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(tf2ss(Tlc),u); // Simulación
plot2d(tiempo,Y,color("red"))
xgrid(color("gray"))
title('Respuesta a lazo cerrado')

